unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Objects, FMX.Layouts, FMX.Ani, FMX.Controls.Presentation,
  FMX.StdCtrls, uGBEImageUtils, RegularExpressions, System.JSON, System.IOUtils, system.Generics.Collections,
  FMX.Effects, FMX.Filter.Effects, FMX.Utils, uGame;

type
  TForm1 = class(TForm)
    layBackground: TLayout;
    recBackground: TRectangle;
    laySecondPlan: TLayout;
    recSecondPlan: TRectangle;
    layNiveau: TLayout;
    recPlateforme: TRectangle;
    joueur: TRectangle;
    aniPlayer: TBitmapListAnimation;
    layPremierPlan: TLayout;
    recPremierPlan: TRectangle;
    GameLoop: TFloatAnimation;
    layInfos: TLayout;
    lblNbCerise: TLabel;
    lblNbPierre: TLabel;
    recDecor: TRectangle;
    recBonus: TRectangle;
    recEnnemi: TRectangle;
    RectAnimation1: TRectAnimation;
    Image1: TImage;
    Image2: TImage;
    layChrono: TLayout;
    layCompteurs: TLayout;
    lblChrono: TLabel;
    layVie: TLayout;
    layCerise: TLayout;
    layPierre: TLayout;
    Image3: TImage;
    lblNbVie: TLabel;
    layZoneJeu: TLayout;
    lblTitre: TLabel;
    layMessage: TLayout;
    Rectangle1: TRectangle;
    lblInfo: TLabel;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      var KeyChar: Char; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure GameLoopProcess(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure aniPlayerFinish(Sender: TObject);
    procedure aniNomNiveauProcess(Sender: TObject);
    procedure Rectangle1Click(Sender: TObject);
  private
    procedure avancer;
    procedure baisser;
    procedure reculer;
    procedure sauter;
    procedure JoueurPositionBorneGauche;
    procedure JoueurPositionBorneDroite;
    procedure ChargerNiveau(nomFichier:string);
    function getPositionJoueur: TPoint;
    function collision(position: TPoint): TGBECollisionResult;
    procedure genererDecor(decor : string);
    procedure genererPlateformes(plateforme: string);
    function getTileImg(num: integer): TBitmap;
    procedure AnimationPrecedente;
    procedure deplacerScrollings(vitesse: single);
    procedure genererBonus(bonus: string);
    procedure genererEnnemi(ennemi: string);
    procedure toucher;
    procedure perdre;
    procedure collisionBonus(position: TPoint);
    procedure collisionEnnemi(position: TPoint);
    procedure ZOrderPlans;
    procedure CreerDeplacement(animation: string; parent : TRectangle; ennemi : boolean = false);
    procedure DeplacerEnnemiFinish(Sender: TObject);
    procedure NouvellePartie;
    procedure gameover;
    procedure victoire;
    { Dclarations prives }
  public
    { Dclarations publiques }
    vitesseX, vitesseY, gravite, oldPlateformePosX, milieuForm : single;
    direction : TDirection;
    variationY, variationX, nbPierre, nbCerise, nbVie, nbPierreMax : integer;
    toucheAvancer, toucheReculer, toucheBaisser, toucheSauter, bloquerRetour, enCollision, estTouche : boolean;
    playerIdle, playerIdleGauche, playerRun, playerRunGauche,
    playerBaisser, playerBaisserGauche, playerSauter, playerToucher, playerSauterGauche, tileSet : TBitmap;
    oldAnimation, nbLine, nbCol, TileSize, nbTilePerLine, playerStartPosX, playerStartPosY : integer;
    tailleNiveau : extended;
    listeDecor : TList<TBitmap>;
    listeBonus : TList<TBonus>;
    listeEnnemis : TList<TEnnemi>;
    listePlateforme : TList<TPlateforme>;
    listeScrollings : TList<TScrolling>;
    dateDebut : TDatetime;
    titreNiveau : string;
  end;

var
  Form1: TForm1;

implementation
{$R *.fmx}

procedure TForm1.GameLoopProcess(Sender: TObject);
var
  position: Tpoint;
  resultatCollision : TGBECollisionResult;
begin
  if nbVie = 0 then begin
    gameover;
    exit;
  end;

  if layNiveau.Position.X <= -tailleNiveau then begin
    if joueur.Position.X > (20 * TileSize) then begin
      if nbPierre = nbPierreMax then begin
        victoire;
        exit;
      end else begin
        lblInfo.Text := 'Vous devez rcuprer les '+nbPierreMax.ToString+' rubis.';
        layMessage.Visible := true;
        layMessage.BringToFront;
      end;
    end else layMessage.Visible := false;
  end;

  position := getPositionJoueur;
  lblNbVie.text := 'x '+nbVie.ToString;
  lblNbCerise.Text := nbCerise.ToString;
  lblNbPierre.Text := nbPierre.ToString + '/'+nbPierreMax.ToString;
  lblChrono.Text := formatdatetime('nn:ss',now-dateDEbut);

  vitesseY := vitesseY + gravite;
  if joueur.Position.Y > (joueur.Position.Y + vitesseY) then variationY := -1
  else variationY := 1;
  if joueur.Position.X > (joueur.Position.X + vitesseX) then variationX := -1
  else variationX := 1;
  joueur.Position.Y := joueur.Position.Y + vitesseY;

  resultatCollision := collision(position);
  if resultatCollision.bool then enCollision := true   // Il faut te sur une plateforme pour pouvoir sauter
  else begin
    enCollision := false;
    oldPlateformePosX := -99999;
  end;

  collisionBonus(position);
  collisionEnnemi(position);

  if (direction = TDirection.gauche) and bloquerRetour then begin
    JoueurPositionBorneGauche;
    exit;
  end;

  if layNiveau.Position.X >= 0 then begin
    JoueurPositionBorneGauche;
    exit;
  end;

  if (layNiveau.Position.X <= - (tailleNiveau) ) then begin
    JoueurPositionBorneDroite;
    exit;
  end;

  deplacerScrollings(vitesseX);

  if joueur.Position.Y > form1.ClientHeight then perdre;
end;

procedure TForm1.perdre;
var scrolling: TScrolling;
begin
  layNiveau.Position.X := 0;
  joueur.Position.X := playerStartPosX;
  joueur.Position.Y := playerStartPosY;
  nbCerise := 0;
  for scrolling in listeScrollings do begin
    scrolling.Position.X := 0;
  end;
  dec(nbVie);
end;

procedure TForm1.Rectangle1Click(Sender: TObject);
begin
  NouvellePartie;
end;

procedure TForm1.deplacerScrollings(vitesse: single);
var
  scrolling : TScrolling;
begin
  for scrolling in listeScrollings do begin
    scrolling.position.X := scrolling.position.X + (vitesse * scrolling.vitesse);
  end;
  layNiveau.Position.X := layNiveau.Position.X + vitesse;
end;

function TForm1.getPositionJoueur:TPoint;
begin
  result.X := Round((joueur.Position.X + abs(layNiveau.Position.X)));
  result.Y := Round((joueur.Position.Y ));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  listeDecor := TList<TBitmap>.create;
  listeBonus := TList<TBonus>.create;
  listeEnnemis := TList<TEnnemi>.create;
  listePlateforme := TList<TPlateforme>.create;
  listeScrollings := TList<TScrolling>.create;

  randomize;
  vitesseY := 0;
  vitesseX := 0;

  layZoneJeu.Scale.X := scale;
  layZoneJeu.Scale.Y := scale;
  form1.ClientWidth := 400 * scale;
  form1.ClientHeight := 224 * scale;
  milieuForm := (form1.ClientWidth * 0.5 / layZoneJeu.Scale.X) - joueur.width;

  playerIdle := TBitmap.Create;
  playerIdle.LoadFromFile('.' + PathDelim + 'sprites' + PathDelim + 'player-idle.png');
  playerIdleGauche := TBitmap.Create;
  playerIdleGauche.LoadFromFile('.' + PathDelim + 'sprites' + PathDelim + 'player-idle-gauche.png');
  playerRun := TBitmap.Create;
  playerRun.LoadFromFile('.' + PathDelim + 'sprites' + PathDelim + 'player-run.png');
  playerRunGauche := TBitmap.Create;
  playerRunGauche.LoadFromFile('.' + PathDelim + 'sprites' + PathDelim + 'player-run-gauche.png');
  playerBaisser := TBitmap.Create;
  playerBaisser.LoadFromFile('.' + PathDelim + 'sprites' + PathDelim + 'player-crouch.png');
  playerBaisserGauche := TBitmap.Create;
  playerBaisserGauche.LoadFromFile('.' + PathDelim + 'sprites' + PathDelim + 'player-crouch-gauche.png');
  playerSauter := TBitmap.Create;
  playerSauter.LoadFromFile('.' + PathDelim + 'sprites' + PathDelim + 'sauter.png');
  playerSauterGauche := TBitmap.Create;
  playerSauterGauche.LoadFromFile('.' + PathDelim + 'sprites' + PathDelim + 'sauter-gauche.png');
  playerToucher := TBitmap.Create;
  playerToucher.LoadFromFile('.' + PathDelim + 'sprites' + PathDelim + 'player-hurt.png');
  tileSet := TBitmap.Create;
  chargerNiveau('.' + PathDelim + 'levels' + PathDelim + 'niveau-foret.json');
  NouvellePartie;
end;

procedure TForm1.NouvellePartie;
begin
  toucheAvancer := false;
  toucheReculer := false;
  toucheBaisser := false;
  toucheSauter := false;
  bloquerRetour := false;
  estTouche := false;
  oldAnimation := 3;
  direction := TDirection.droite;
  nbPierre := 0;
  nbCerise := 0;
  nbVie := 3;
  lblTitre.Text := titreNiveau;
  dateDebut := now;
  GameLoop.Start;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  listeDecor.Free;
  listeBonus.Free;
  listeEnnemis.Free;
  listePlateforme.Free;
  listeScrollings.Free;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if (keyChar = 'D') or (keyChar = 'd') or (key = 39) then avancer;
  if (keyChar = 'Q') or (keyChar = 'q') or (keyChar = 'A') or (keyChar = 'a') or (key = 37) then reculer;  // Q pour cavier AZERT, A pour clavier QWERTY
  if (keyChar = 'S') or (keyChar = 's') or (key = 40) then baisser;
  if keyChar = ' ' then sauter;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if (keyChar = 'D') or (keyChar = 'd') or (key = 39) then begin
    toucheAvancer := false;
    oldAnimation := 3;
    vitesseX := 0;
  end;
  if (keyChar = 'Q') or (keyChar = 'q') or (key = 37) then begin
    toucheReculer := false;
    oldAnimation := 4;
    vitesseX := 0;
  end;
  if (keyChar = 'S') or (keyChar = 's') or (key = 40) then toucheBaisser := false;

  if not(toucheAvancer) and not(toucheReculer) and not(toucheBaisser) and not(toucheSauter) then begin
    if direction = TDirection.gauche then begin
      aniPlayer.AnimationBitmap := playerIdleGauche;
      aniPlayer.AnimationCount := 4;
      oldAnimation := 4;
    end else begin
      aniPlayer.AnimationBitmap := playerIdle;
      aniPlayer.AnimationCount := 4;
      oldAnimation := 3;
    end;
  end;
end;

procedure TForm1.JoueurPositionBorneGauche;
begin
  if joueur.Position.X >= 0 then begin
    joueur.Position.X := joueur.Position.X - vitesseX;
    if joueur.Position.X >= milieuForm then layNiveau.Position.X := -0.0001;
  end else joueur.Position.X := 0;
end;

procedure TForm1.JoueurPositionBorneDroite;
begin
  if joueur.Position.X <= (form1.ClientWidth - (joueur.Width* scale)) / scale then begin
    joueur.Position.X := joueur.Position.X - vitesseX;
    if joueur.Position.X <= milieuForm then layNiveau.Position.X := - (tailleNiveau) +1;
  end else joueur.Position.X := (form1.ClientWidth - (joueur.Width * scale)) / scale;
end;

procedure TForm1.AnimationPrecedente;
begin
  toucheSauter := false;
  case oldAnimation of
    1: begin
         aniPlayer.AnimationBitmap := playerRun;
         aniPlayer.AnimationCount := 6;
       end;
    2: begin
         aniPlayer.AnimationBitmap := playerRunGauche;
         aniPlayer.AnimationCount := 6;
       end;
    3: begin
         aniPlayer.AnimationBitmap := playerIdle;
         aniPlayer.AnimationCount := 4;
       end;
    4: begin
         aniPlayer.AnimationBitmap := playerIdleGauche;
         aniPlayer.AnimationCount := 4;
       end;
    5: begin
         aniPlayer.AnimationBitmap := playerBaisser;
         aniPlayer.AnimationCount := 2;
       end;
    6: begin
         aniPlayer.AnimationBitmap := playerBaisserGauche;
         aniPlayer.AnimationCount := 2;
       end;
    7: begin
         aniPlayer.AnimationBitmap := playerToucher;
         aniPlayer.AnimationCount := 2;
       end;
  end;
end;

function TForm1.collision(position : TPoint):TGBECollisionResult;
var
  i : integer;
  unRectangle: TRectangle;
  demiLargeur, demiHauteur : integer;
  oldX : single;
begin
  result.bool := false;
  result.objet := nil;
  demiLargeur := trunc(joueur.Width *0.5);
  demiHauteur := trunc(joueur.Height *0.5);

  // Collision avec plateforme
  for I := 0 to recPlateforme.ChildrenCount-1 do begin
    unRectangle := recPlateforme.Children[i] as TRectangle;

    // Collision sur X
    if (position.X + joueur.width - 6 >= unRectangle.Position.X) and (position.X + 6 <= (unRectangle.Position.X + unRectangle.Width)) then begin

      if position.X + joueur.width - 6 >= unRectangle.Position.X then oldX := -0.1
      else oldX := +0.1;

      if unRectangle.Opacity > 0.1 then begin
        if (unRectangle.Tag = 2) and (variationY > 0) then begin
          if (Round(position.y + joueur.height) >= Round(unRectangle.Position.Y)) and
             (Round(position.y + joueur.height) <= Round( (unRectangle.Position.Y + unRectangle.Height))) then begin
               result.bool := true;
               result.objet := unRectangle;
               joueur.Position.Y := unRectangle.Position.Y - joueur.Height+1;
               if unRectangle.ChildrenCount = 1 then begin
                 if (unRectangle.Children[0] as TFloatAnimation).PropertyName.ToLower = 'position.x'  then begin
                   if oldPlateformePosX = -99999 then oldPlateformePosX := unRectangle.Position.X;
                   deplacerScrollings( oldPlateformePosX - unRectangle.Position.X);
                   oldPlateformePosX := unRectangle.Position.X;
                 end;
               end;
               vitesseY := 0;
               AnimationPrecedente;
          end;
          joueur.RotationAngle := unRectangle.RotationAngle;
        end;

        if unRectangle.Tag = 1 then begin
          if (Round(position.y + joueur.height) >= Round(unRectangle.Position.Y)) and
             (Round(position.y ) <= Round( (unRectangle.Position.Y + unRectangle.Height))) then begin
               result.bool := true;
               result.objet := unRectangle;
               vitesseX := 0;
               vitesseY := 0;
               deplacerScrollings(oldX);
               AnimationPrecedente;
             end;
        end;
      end;
    end;
  end;
end;

procedure TForm1.collisionBonus(position : TPoint);
var
  i : integer;
  unBonus : TRectangle;
  demiLargeur, demiHauteur : integer;
begin
  demiLargeur := trunc(joueur.Width *0.5);
  demiHauteur := trunc(joueur.Height *0.5);

  for I := 0 to recBonus.ChildrenCount-1 do begin
    unBonus := recBonus.Children[i] as TRectangle;

    if (position.X  >= unBonus.Position.X) and (position.X  <= (unBonus.Position.X + unBonus.Width)) then begin
      if (Round(position.y + demiHauteur  ) > Round(unBonus.Position.Y)) and
         (Round(position.y  ) < Round( (unBonus.Position.Y + unBonus.Height))) then begin
         case unBonus.Tag of
           0: inc(nbCerise);
           1: inc(nbPierre);
         end;
         unBonus.free;
         break;
      end;
    end;
  end;
end;

procedure TForm1.collisionEnnemi(position : TPoint);
var
  i : integer;
  unEnnemi : TRectangle;
  demiLargeur, demiHauteur : integer;
begin
  demiLargeur := trunc(joueur.Width *0.5);
  demiHauteur := trunc(joueur.Height *0.5);

  for I := 0 to recEnnemi.ChildrenCount-1 do begin
    unEnnemi := recEnnemi.Children[i] as TRectangle;
    if (position.X >= unEnnemi.Position.X) and (position.X <= (unEnnemi.Position.X + unEnnemi.Width)) then begin
      if (Round(position.y + demiHauteur ) > Round(unEnnemi.Position.Y)) and
        (Round(position.y  ) < Round( (unEnnemi.Position.Y + unEnnemi.Height))) then begin
         toucher;
         break;
      end;
    end;
  end;
end;

procedure TForm1.aniNomNiveauProcess(Sender: TObject);
begin
  ((sender as TFLoatAnimation).Parent as TLabel).Opacity := ((sender as TFLoatAnimation).Parent as TLabel).Opacity - 0.004;
end;

procedure TForm1.aniPlayerFinish(Sender: TObject);
begin
  AnimationPrecedente;
  deplacerScrollings(1);
end;

procedure TForm1.avancer;
begin
  oldAnimation := 1;
  toucheAvancer := true;
  aniPlayer.AnimationBitmap := playerRun;
  aniPlayer.AnimationCount := 6;
  vitesseX := -vitesseXMax;
  direction := TDirection.droite;
end;

procedure TForm1.reculer;
begin
  oldAnimation := 2;
  toucheReculer := true;
  aniPlayer.AnimationBitmap := playerRunGauche;
  aniPlayer.AnimationCount := 6;
  vitesseX := vitesseXMax;
  direction := TDirection.gauche;
end;

procedure TForm1.baisser;
begin
  toucheAvancer := false;
  toucheReculer := false;
  toucheBaisser := true;
  if direction = TDirection.droite then begin
    aniPlayer.AnimationBitmap := playerBaisser;
    oldAnimation := 5;
  end else begin
    aniPlayer.AnimationBitmap := playerBaisserGauche;
    oldAnimation := 6;
  end;
  vitesseX := 0;
  aniPlayer.AnimationCount := 2;
end;

procedure TForm1.toucher;
begin
  if nbCerise = 0 then perdre
  else begin
    if not(estTouche) then begin
      estTouche := true;
      GameLoop.Stop;
      aniPlayer.AnimationBitmap := playerToucher;
      aniPlayer.AnimationCount := 2;
      aniPlayer.Start;
      nbCerise := 0;
      vitesseX := 0;
      if direction = TDirection.droite then begin
        deplacerScrollings(TileSize*2);
        toucheAvancer := false;
        oldAnimation := 3;
      end else begin
        deplacerScrollings(-TileSize*2);
        toucheReculer := false;
        oldAnimation := 4;
      end;
      estTouche := false;
      GameLoop.Start;
    end;
  end;
end;

procedure TForm1.sauter;
begin
  if enCollision then begin
    if not(toucheSauter) then begin
      toucheBaisser := false;
      toucheSauter := true;
      if direction = TDirection.droite then aniPlayer.AnimationBitmap := playerSauter
      else aniPlayer.AnimationBitmap := playerSauterGauche;
      aniPlayer.AnimationCount := 1;
      vitesseY := - vitesseSaut;
    end;
  end;
end;

procedure TForm1.ChargerNiveau(nomFichier:string);
var
  x, y, i, foisX, foisY : integer;
  fichier : TStringlist;
  tabTile, infoTile : TArray<String>;
  JSONValue : TJSONValue;
  s, decor, plateformes, bonus, ennemis : string;
  decorArr, plateformesArr, bonusArr, ennemiArr, scrollingArr : TJSONArray;
  unePlateforme : TPlateForme;
  unScrolling : TScrolling;
  unEnnemi : TEnnemi;
  unBonus : TBonus;
begin

  if fileexists(nomfichier) then begin
    JSONValue := TJSONObject.ParseJSONValue(TFile.ReadAllText(nomFichier));
    try
      if JsonValue <> nil then begin

        if JSONVAlue is TJSONObject then begin
          nbLine := JSONValue.GetValue<integer>('height');
          nbCol := JSONValue.GetValue<integer>('width');
          TileSize := JSONValue.GetValue<integer>('tileSize');
          titreNiveau := JSONValue.GetValue<string>('nom');
          tailleNiveau := TileSize * nbCol;

          scrollingArr := JSONValue.GetValue<TJSONArray>('scrollings');
          for I := 0 to scrollingArr.Count-1 do begin
             unScrolling := TScrolling.Create(nil);
             unScrolling.Parent := layZoneJeu;
             unScrolling.Height := scrollingArr[i].GetValue<integer>('height');
             unScrolling.Position.Y := scrollingArr[i].GetValue<integer>('posY');
             unScrolling.Scale.X := scrollingArr[i].GetValue<single>('scaleX');
             unScrolling.Scale.Y := scrollingArr[i].GetValue<single>('scaleY');
             unScrolling.rectangle.Height := scrollingArr[i].GetValue<integer>('height');
             unScrolling.rectangle.Width := tailleNiveau;
             unScrolling.rectangle.Fill.Bitmap.Bitmap.LoadFromFile('.' + PathDelim + 'img' + PathDelim + scrollingArr[i].GetValue<string>('image'));
             unScrolling.zOrder := scrollingArr[i].GetValue<integer>('zorder');
             unScrolling.vitesse := scrollingArr[i].GetValue<single>('vitesse');
             listeScrollings.Add(unScrolling);
          end;

          ZOrderPlans;

          decorArr := JSONValue.GetValue<TJSONArray>('decorElement');
          for I := 0 to decorArr.Count-1 do begin
             listeDecor.Add(TBitmap.CreateFromFile('.' + PathDelim + 'img' + PathDelim + decorArr[i].GetValue<string>('image')));
          end;

          plateformesArr := JSONValue.GetValue<TJSONArray>('plateformElement');
          for i := 0 to plateformesArr.Count-1 do begin
            unePlateforme.image := plateformesArr.Items[i].GetValue<string>('image');
            unePlateforme.style := TTileStyle(plateformesArr.Items[i].GetValue<integer>('style'));
            unePlateforme.animation := plateformesArr.Items[i].GetValue<string>('animation').ToLower;
            listePlateforme.Add(unePlateforme);
          end;

          bonusArr := JSONValue.GetValue<TJSONArray>('bonusElement');
          for I := 0 to bonusArr.Count-1 do begin
            unBonus.image := '.' + PathDelim + 'sprites' + PathDelim + bonusArr[i].GetValue<string>('image');
            unBonus.count := bonusArr[i].GetValue<integer>('count');
            unBonus.duration := bonusArr[i].GetValue<single>('duration');
            listeBonus.Add(unBonus);
          end;

          ennemiArr := JSONValue.GetValue<TJSONArray>('ennemiElement');
          for I := 0 to ennemiArr.Count-1 do begin
            unEnnemi.image1 := '.' + PathDelim + 'sprites' + PathDelim + ennemiArr[i].GetValue<string>('image1');
            unEnnemi.image2 := '.' + PathDelim + 'sprites' + PathDelim + ennemiArr[i].GetValue<string>('image2');
            unEnnemi.count := ennemiArr[i].GetValue<integer>('count');
            unEnnemi.duration := ennemiArr[i].GetValue<single>('duration');
            unEnnemi.deplacement := ennemiArr[i].GetValue<string>('deplacement');
            listeEnnemis.Add(unEnnemi);
          end;

          tileSet.LoadFromFile('.' + PathDelim + 'img' + PathDelim + JSONValue.GetValue<string>('tileImage'));
          nbTilePerLine := JSONValue.GetValue<integer>('nbTilePerLine');
          gravite := JSONValue.GetValue<single>('gravite');
          playerStartPosX := JSONValue.GetValue<integer>('playerStartPosX');
          playerStartPosY := JSONValue.GetValue<integer>('playerStartPosY');

          decor := JSONValue.GetValue<string>('niveau.decor');
          plateformes := JSONValue.GetValue<string>('niveau.plateformes');
          bonus := JSONValue.GetValue<string>('niveau.bonus');
          ennemis := JSONValue.GetValue<string>('niveau.ennemis');
        end;
      end;
    finally
      JSONValue.Free;
    end;

    genererDecor(decor);
    genererPlateformes(plateformes);
    genererBonus(bonus);
    genererEnnemi(ennemis);
    joueur.Position.X := playerStartPosX;
    joueur.Position.Y := playerStartPosY+1;
  end;
end;

procedure TForm1.genererDecor(decor : string);
var
  tabDecor, infoDecor : TArray<String>;
  i : integer;
  rec : TRectangle;
begin
  tabDecor := TRegEx.Split(decor, ';');

  for I := 0 to length(tabDecor) -1 do begin
    infoDecor := TRegEx.Split(tabDecor[i], ':');
    rec := TRectangle.Create(nil);
    rec.Name := 'decor' + i.ToString;
    rec.Parent := recDecor;
    rec.Fill.Kind := TBrushKind.Bitmap;
    if copy(infoDecor[0],1,1).ToLower = 't' then rec.Fill.Bitmap.Bitmap := getTileImg(StrToIntDef(copy(infoDecor[0],2, length(infoDecor[0])),0))
    else rec.Fill.Bitmap.Bitmap := listeDecor[StrToIntDef(infoDecor[0],0)];
    rec.width := rec.Fill.Bitmap.Bitmap.Width;
    rec.Height := rec.Fill.Bitmap.Bitmap.Height;
    rec.Stroke.Kind := TBrushKind.solid;
    rec.Position.X := StrToIntDef(infoDecor[2],0) * TileSize +1;
    rec.Position.Y := StrToIntDef(infoDecor[1],0) * TileSize  - rec.Height + 2;
    rec.Stroke.Color := TAlphaColorRec.null;
    rec.Stroke.Thickness := 1;
  end;
end;

procedure TForm1.genererPlateformes(plateforme : string);
var
  tabPlateforme, infoPlateforme, tabImage : TArray<String>;
  i, j : integer;
  rec : TRectangle;
  image, deplacement: string;
  bmp : TBitmap;
begin
  tabPlateforme := TRegEx.Split(plateforme, ';');

  for I := 0 to length(tabPlateforme) -1 do begin
    infoPlateforme := TRegEx.Split(tabPlateforme[i], ':');
    rec := TRectangle.Create(nil);
    rec.Name := 'plateforme' + i.ToString;
    rec.Parent := recPlateforme;
    rec.Fill.Kind := TBrushKind.Bitmap;

    image := listePlateforme[ strtointdef(infoPlateforme[0],0) ].image;
    tabImage := TregEx.Split(image, ':');
    bmp := TBitmap.Create;
    bmp.Width := length(tabImage) * TileSize;
    bmp.Height := TileSize;

    for j := 0 to Length(tabImage) -1 do begin
      bmp.CopyFromBitmap(getTileImg(strtointdef(tabImage[j],0)), Rect(0,0, TileSize, tileSize), tilesize * j, 0);
    end;

    rec.Fill.Bitmap.Bitmap := bmp;
    rec.width := rec.Fill.Bitmap.Bitmap.Width;
    rec.Height := rec.Fill.Bitmap.Bitmap.Height;
    rec.Stroke.Kind := TBrushKind.Solid;
    rec.Stroke.Color := TAlphaColorRec.null;
    rec.Stroke.Thickness := 1;
    rec.Position.X := StrToIntDef(infoPlateforme[2],0) * TileSize;
    rec.Position.Y := StrToIntDef(infoPlateforme[1],0) * TileSize - rec.Height +1;

    case listePlateforme[ strtointdef(infoPlateforme[0],0) ].style of
      vide : rec.Tag := 0;
      bloc : rec.Tag := 1;
      blocHaut : rec.Tag := 2;
      blocGauche : rec.Tag := 3;
      blocDroit : rec.Tag := 4;
      blocBas : rec.Tag := 5;
      eau : rec.Tag := 6;
      sable : rec.Tag := 7;
      ressort : rec.Tag := 8;
      trou : rec.Tag := 9;
      bonusVie : rec.Tag := 10;
      bonus : rec.Tag := 11;
    end;

    deplacement := listePlateforme[ strtointdef(infoPlateforme[0],0) ].animation;
    CreerDeplacement(deplacement, rec);
  end;
end;

procedure TForm1.CreerDeplacement(animation : string; parent : TRectangle; ennemi : boolean = false);
var
  tabAnimation : TArray<String>;
  floatAni : TFloatAnimation;
begin
  tabAnimation := TRegEx.Split(animation, ':');
  if (tabAnimation[0] = 'x') or (tabAnimation[0] = 'y') or (tabAnimation[0] = 'r') or (tabAnimation[0] = 'o') then begin
    floatAni := TFloatAnimation.Create(nil);
    floatAni.Parent := parent;
    if tabAnimation[5].toLower = 'loop' then floatAni.Loop := true
    else floatAni.Loop := false;
    if tabAnimation[6].toLower = 'autoreverse' then floatAni.AutoReverse := true
    else floatAni.AutoReverse := false;
    if tabAnimation[3].ToLower = 'linear' then floatAni.Interpolation := TInterpolationType.Linear;
    if tabAnimation[3].ToLower = 'sinusoidal' then floatAni.Interpolation := TInterpolationType.Sinusoidal;
    if tabAnimation[3].ToLower = 'quadratic' then floatAni.Interpolation := TInterpolationType.Quadratic;
    if tabAnimation[3].ToLower = 'cubic' then floatAni.Interpolation := TInterpolationType.Cubic;
    if tabAnimation[3].ToLower = 'quartic' then floatAni.Interpolation := TInterpolationType.Quartic;
    if tabAnimation[3].ToLower = 'quintic' then floatAni.Interpolation := TInterpolationType.Quintic;
    if tabAnimation[3].ToLower = 'exponential' then floatAni.Interpolation := TInterpolationType.Exponential;
    if tabAnimation[3].ToLower = 'circular' then floatAni.Interpolation := TInterpolationType.Circular;
    if tabAnimation[3].ToLower = 'elastic' then floatAni.Interpolation := TInterpolationType.Elastic;
    if tabAnimation[3].ToLower = 'back' then floatAni.Interpolation := TInterpolationType.Back;
    if tabAnimation[3].ToLower = 'bounce' then floatAni.Interpolation := TInterpolationType.Bounce;

    if tabAnimation[4].ToLower = 'in' then floatAni.AnimationType := TAnimationType.In;
    if tabAnimation[4].ToLower = 'out' then floatAni.AnimationType := TAnimationType.Out;
    if tabAnimation[4].ToLower = 'inout' then floatAni.AnimationType := TAnimationType.InOut;

    floatAni.Duration := strtointdef(tabAnimation[1],5);

    if tabAnimation[0] = 'x' then begin
      floatAni.PropertyName := 'position.X';
      floatAni.StartValue := parent.Position.X;
      floatAni.StopValue := parent.Position.X + strtointdef(tabAnimation[2],0) * TileSize;
    end;
    if tabAnimation[0] = 'y' then begin
      floatAni.PropertyName := 'position.Y';
      floatAni.StartValue := parent.Position.Y;
      floatAni.StopValue := parent.Position.Y + strtointdef(tabAnimation[2],0) * TileSize;
    end;
    if tabAnimation[0] = 'r' then begin
      floatAni.PropertyName := 'rotationangle';
      floatAni.StartValue := 0;
      floatAni.StopValue := strtointdef(tabAnimation[2],0);
    end;
    if tabAnimation[0] = 'o' then begin
      floatAni.PropertyName := 'opacity';
      floatAni.StartValue := 0;
      floatAni.StopValue := strtointdef(tabAnimation[2],0);
    end;

    if ennemi then floatAni.OnFinish := DeplacerEnnemiFinish;
    floatAni.Start;
  end;
end;

function TForm1.getTileImg(num : integer):TBitmap;
var
  lg, col : integer;
  imgTile : TBitmap;
begin
  imgTile := TBitmap.Create;
  imgTile.Width := TileSize;
  imgTile.Height := TileSize;
  lg := num div nbTilePerLine;
  col := num mod nbTilePerLine;
  imgTile := cropImage(tileset,col * tileSize, lg * tilesize, tilesize, tilesize);
  result := imgTile;
end;

procedure TForm1.genererBonus(bonus : string);
var
  tabBonus, infoBonus : TArray<String>;
  i : integer;
  rec : TRectangle;
  animation: TBitmapListAnimation;
begin
  tabBonus := TRegEx.Split(bonus, ';');
  nbPierreMax := 0;

  for I := 0 to length(tabBonus) -1 do begin
    infoBonus := TRegEx.Split(tabBonus[i], ':');
    rec := TRectangle.Create(nil);
    rec.Name := 'bonus' + i.ToString;
    rec.Parent := recBonus;
    rec.Fill.Kind := TBrushKind.Bitmap;
    animation := TBitmapListAnimation.Create(nil);
    animation.AnimationType := TAnimationType.InOut;
    animation.Interpolation := TInterpolationType.Sinusoidal;
    animation.Parent := rec;
    rec.Tag := StrToIntDef(infoBonus[0],0);
    if rec.tag = 1 then inc(nbPierreMax);

    animation.AnimationBitmap.LoadFromFile(listeBonus[StrToIntDef(infoBonus[0],0)].image);
    animation.AnimationCount := listeBonus[StrToIntDef(infoBonus[0],0)].count;
    animation.Loop := true;
    animation.Inverse := random(2) = 1;
    animation.Duration := listeBonus[StrToIntDef(infoBonus[0],0)].duration;
    animation.AutoReverse := true;
    animation.PropertyName := 'fill.Bitmap.bitmap';
    animation.Start;
    rec.width := rec.Fill.Bitmap.Bitmap.Width;
    rec.Height := rec.Fill.Bitmap.Bitmap.Height;
    rec.Stroke.Kind := TBrushKind.None;
    rec.Position.X := StrToIntDef(infoBonus[2],0) * TileSize;
    rec.Position.Y := StrToIntDef(infoBonus[1],0) * TileSize  - rec.Height;
    rec.Stroke.Color := TAlphaColorRec.Null;
    rec.Stroke.Thickness := 1;
  end;
end;

procedure TForm1.genererEnnemi(ennemi : string);
var
  tabEnnemi, infoEnnemi : TArray<String>;
  i : integer;
  rec : TRectangle;
  deplacement: string;
  animation: TBitmapListAnimation;
begin
  tabEnnemi := TRegEx.Split(ennemi, ';');

  for I := 0 to length(tabEnnemi) -1 do begin
    infoEnnemi := TRegEx.Split(tabEnnemi[i], ':');
    rec := TRectangle.Create(nil);
    rec.Name := 'ennemi' + i.ToString;
    rec.Parent := recEnnemi;
    rec.Fill.Kind := TBrushKind.Bitmap;
    animation := TBitmapListAnimation.Create(nil);
    animation.Parent := rec;
    rec.Tag := 0;//StrToIntDef(infoEnnemi[0],0);
    animation.AnimationBitmap.LoadFromFile(listeEnnemis[StrToIntDef(infoEnnemi[0],0)].image1);
    animation.AnimationCount := listeEnnemis[StrToIntDef(infoEnnemi[0],0)].count;
    animation.Loop := true;
    animation.Duration := listeEnnemis[StrToIntDef(infoEnnemi[0],0)].duration;
    animation.AutoReverse := false;
    animation.AnimationType := TAnimationType.InOut;
    animation.PropertyName := 'fill.Bitmap.bitmap';
    animation.Interpolation := TInterpolationType.Linear;
    animation.Start;

    rec.Hint := listeEnnemis[StrToIntDef(infoEnnemi[0],0)].image1+';'+listeEnnemis[StrToIntDef(infoEnnemi[0],0)].image2;
    rec.width := rec.Fill.Bitmap.Bitmap.Width;
    rec.Height := rec.Fill.Bitmap.Bitmap.Height;
    rec.Stroke.Kind := TBrushKind.Solid;
    rec.Position.X := StrToIntDef(infoEnnemi[2],0) * TileSize;
    rec.Position.Y := StrToIntDef(infoEnnemi[1],0) * TileSize  - rec.Height +2;
    rec.Stroke.Color := TAlphaColorRec.Null;
    rec.Stroke.Thickness := 1;

    deplacement := listeEnnemis[ strtointdef(infoEnnemi[0],0) ].deplacement;
    CreerDeplacement(deplacement, rec, true);
  end;
end;

procedure TForm1.ZOrderPlans;
var
  scrolling : TScrolling;
  ZorderOTraite : boolean;
begin
  ZorderOTraite := false;
  for scrolling in listeScrollings do begin
    if scrolling.ZOrder < 0 then begin
      if not(ZorderOTraite) then begin
        layNiveau.BringToFront;
        joueur.BringToFront;
        ZorderOTraite := true;
      end;
    end;
    scrolling.BringToFront;
  end;
  layInfos.BringToFront;
end;

procedure TForm1.DeplacerEnnemiFinish(Sender: TObject);
begin
  if ((sender as TFloatAnimation).Parent as TRectangle).tag = 0 then begin
    (((sender as TFloatAnimation).Parent as TRectangle).Children[0] as TBitmapListAnimation).AnimationBitmap.LoadFromFile(((sender as TFloatAnimation).Parent as TRectangle).hint.split([';'])[1]);
    ((sender as TFloatAnimation).Parent as TRectangle).tag := 1;
    (sender as TFloatAnimation).Inverse := true;
  end else begin
    (((sender as TFloatAnimation).Parent as TRectangle).Children[0] as TBitmapListAnimation).AnimationBitmap.LoadFromFile(((sender as TFloatAnimation).Parent as TRectangle).hint.split([';'])[0]);
    ((sender as TFloatAnimation).Parent as TRectangle).tag := 0;
    (sender as TFloatAnimation).Inverse := false;
  end;
  (sender as TFloatAnimation).Start;
end;

procedure TForm1.gameover;
begin
  lblInfo.Text := 'Perdu... :('+sLineBreak+ 'Relancez le jeu pour dbuter une nouvelle partie.';
  layMessage.Visible := true;
  layZoneJeu.Visible := false;
  layMessage.BringToFront;
end;

procedure TForm1.victoire;
begin
  lblInfo.Text := 'Flicitations !!!'+sLineBreak+ 'Vous avez gagn en '+ lblChrono.Text+''+sLineBreak+
                  'Relancez le jeu pour dbuter une nouvelle partie.';
  layMessage.Visible := true;
  layZoneJeu.Visible := false;
  layMessage.BringToFront;
end;

end.
